#ifndef BatchLab_HDF5_ReadContext_h
#define BatchLab_HDF5_ReadContext_h

#include <string>
#include <hdf5.h>

namespace Slash {namespace Core {class IWriter;}}

namespace BatchLab {namespace HDF5 {class HDF5O;}}

namespace BatchLab {

namespace HDF5 {

class ReadContext {
public:
  ReadContext(int,Slash::Core::IWriter&,
              hid_t,const std::string&,int,
              HDF5O&);
  virtual ~ReadContext();
public:
  int verboseLevel() const;
  Slash::Core::IWriter& printer() const;
  hid_t id() const;
  std::string name() const;
  int version() const;
  HDF5O& helper() const;
private:
  int fVerboseLevel;
  Slash::Core::IWriter& fPrinter;
  hid_t fID;
  std::string fName;
  int fVersion;
  HDF5O& fHDF5O;
};

} //HDF5
 
} //BatchLab

#endif
