#include "AIDA/AIDA.h"
using namespace AIDA;

using namespace std; //GB

#include <iostream>

int main()
{
  IAnalysisFactory *analysisFactory = AIDA_createAnalysisFactory();

  ITreeFactory *treeFactory = analysisFactory->createTreeFactory();

  //GB ITree *tree = treeFactory->create();
  ITree *tree = treeFactory->create("gaussian.aida","xml",true,false); //GB
  delete treeFactory; //GB : no more needed.

  IManagedObject* managedObject= tree->find("/tuplePhoton");
  if(!managedObject) cout<<"this pointer is NULL:"<<endl;
  if(managedObject)  cout<<"managedObject pointer is pointed to:"<<managedObject->name()<<endl;

  //GB : the below      (AIDA::ITuple*) was missing in the original program.
  AIDA::ITuple *tuple = dynamic_cast<AIDA::ITuple*>(managedObject);
  if(!tuple) {
    std::cout << "can't cast IManagedObject to ITuple." << std::endl;
    return 0;
  }

  //GB : The loop :
  tuple->start();
  while ( tuple->next() ) {

    //GB : use getDouble is the variable had been booked with double.
    double r1 = tuple->getDouble(0); //r1
    double r2 = tuple->getDouble(1); //r2
    double r3 = tuple->getDouble(2); //r3

    std::cout << " r1 " << r1 
              << ", r2 = " << r2 
              << ", r3 = " << r3 
              << std::endl;
  }

  //tree->commit(); //GB : not needed when reading.
  tree->close();  

  delete analysisFactory; //GB : to delete all AIDA related things.

        return 0;
}
