#define SbPolyhedronSphere G4PolyhedronSphere
#define SbPolyhedronBox    G4PolyhedronBox
#define SbPolyhedronTube   G4PolyhedronTube
#define SbPolyhedron       G4Polyhedron
#define SbVec3f            HepGeom::Point3D<double>

#include <G4Polyhedron.hh>
#include <CLHEP/Geometry/Point3D.h>
#include <CLHEP/Geometry/Transform3D.h>
#include <CLHEP/Vector/RotationX.h>

//#define OPERATION add
//
#define OPERATION subtract

int main() {
  double pi = 3.1415926535897931160E0;
  double rad = 1.0;
  double mm = 1.0;

  double Rh2SphMirror33InnerR = 8631*mm;
  double Rh2SphMirrorInnerR = 8600.0*mm;
  double Rh2SphMirrorThickness = 6.0*mm;
  double Rh2SPhMirrorSegHexDiagSize = 510.0*mm;

  double Rh2SPhMirrHexSubBoxLargeXSize = 200000.0*mm;
  double Rh2SPhMirrHexSubBoxLargeYSize = 200000.0*mm;
  double Rh2SPhMirrHexSubBoxLargeZSize = 400000.0*mm;

  //double Rh2SPhMirrHexSubBoxLargeXSize = 200.0*mm;
  //double Rh2SPhMirrHexSubBoxLargeYSize = 240.0*mm;
  //double Rh2SPhMirrHexSubBoxLargeZSize = 400.0*mm;

  double Rh2SPhMirrorHexParam60 = (pi/3.0)*rad;
  double Rh2SPhMirrorHexParam30 = (pi/6.0)*rad;
  double Rh2SPhMirrorHexCos60 = cos(Rh2SPhMirrorHexParam60);
  double Rh2SPhMirrorHexCos30 = cos(Rh2SPhMirrorHexParam30);
  double Rh2SPhMirrorHexSin60 = sin(Rh2SPhMirrorHexParam60);
  double Rh2SPhMirrorHexSin30 = sin(Rh2SPhMirrorHexParam30);

  double Rh2SphMirror33OutR = Rh2SphMirror33InnerR + Rh2SphMirrorThickness;

  double Rh2SphMirrHexSegHorizSize = Rh2SPhMirrorSegHexDiagSize*Rh2SPhMirrorHexSin60;

  double Rh2SphMirrHexDeltaTheta = (2.0*asin(Rh2SphMirrHexSegHorizSize/(2.0*Rh2SphMirrorInnerR)))*rad;

  double Rh2SphMirrHexStartTheta = (pi/2.0)*rad-(Rh2SphMirrHexDeltaTheta/2.0);

  double Rh2SphMirrHexSegVertSize = Rh2SPhMirrorSegHexDiagSize;

  double Rh2SphMirrHexDeltaPhi= (2.0*asin(Rh2SphMirrHexSegVertSize/(2.0*Rh2SphMirrorInnerR)))*rad;

  double Rh2SphMirrHexStartPhi = -1.0*(Rh2SphMirrHexDeltaPhi/2.0);

  double Rh2SphMirrHexSegFlatHalfSize = 0.5*Rh2SPhMirrorSegHexDiagSize*Rh2SPhMirrorHexSin60;
  double Rh2SphMirrHexSegDiagHalfSize = 0.5*Rh2SPhMirrorSegHexDiagSize;
 
  double Rh2SphMirrorOuterR = Rh2SphMirrorInnerR+Rh2SphMirrorThickness;

  double Rh2SphMirrHexSubBoxShiftX = Rh2SphMirrorOuterR;
      

  double Rh2SphMirr33HexDeltaTheta = (2.0*asin(Rh2SphMirrHexSegHorizSize/(2.0*Rh2SphMirror33InnerR)))*rad;
  double Rh2SphMirr33HexDeltaPhi = (2.0*asin(Rh2SphMirrHexSegVertSize/(2.0*Rh2SphMirror33InnerR)))*rad;
  double Rh2SphMirr33HexStartTheta = (pi/2.0)*rad-(Rh2SphMirr33HexDeltaTheta/2.0);
  double Rh2SphMirr33HexStartPhi = -1.0*(Rh2SphMirr33HexDeltaPhi/2.0);

  double Rh2SphMirrHexSubBoxShiftY = (0.5*Rh2SPhMirrorSegHexDiagSize*Rh2SPhMirrorHexSin60+0.5*Rh2SPhMirrHexSubBoxLargeZSize)*Rh2SPhMirrorHexSin60;
  double Rh2SphMirrHexSubBoxShiftZ = (0.5*Rh2SPhMirrorSegHexDiagSize*Rh2SPhMirrorHexSin60+0.5*Rh2SPhMirrHexSubBoxLargeZSize)*Rh2SPhMirrorHexCos60;

  double Rh2SphMirrHexSubBoxRotX = Rh2SPhMirrorHexParam60;

  double Rh2SphMirrHexSubBoxShiftYQ0 = Rh2SphMirrHexSubBoxShiftY;

  double Rh2SphMirrHexSubBoxShiftZQ0 = Rh2SphMirrHexSubBoxShiftZ;
  double Rh2SphMirrHexSubBoxShiftZQ1 = -Rh2SphMirrHexSubBoxShiftZ;
  double Rh2SphMirrHexSubBoxShiftZQ2 = -Rh2SphMirrHexSubBoxShiftZ;
  double Rh2SphMirrHexSubBoxShiftZQ3 = Rh2SphMirrHexSubBoxShiftZ;

  double Rh2SphMirrHexSubBoxRotXQ02 = -Rh2SphMirrHexSubBoxRotX;


  double Rh2SphMirrHexSubBoxRotXQ13 = Rh2SphMirrHexSubBoxRotX;
  double Rh2SphMirrHexSubBoxShiftYQ1 = Rh2SphMirrHexSubBoxShiftY;
  double Rh2SphMirrHexSubBoxShiftYQ2 = -Rh2SphMirrHexSubBoxShiftY;
  double Rh2SphMirrHexSubBoxShiftYQ3 = -Rh2SphMirrHexSubBoxShiftY;

/*
  //<logvol name="lvRich2SphMirrorHexSeg33" material="RichMaterials/Rich2MirrorGlass">
  //<subtraction name="lvRich2SphMirrorHexSeg33Sub" >

  double outerRadius = Rh2SphMirror33OutR;
  double innerRadius = Rh2SphMirror33InnerR;
  double startPhiAngle = Rh2SphMirr33HexStartPhi;
  double deltaPhiAngle = Rh2SphMirr33HexDeltaPhi;
  double startThetaAngle = Rh2SphMirr33HexStartTheta;
  double deltaThetaAngle = Rh2SphMirr33HexDeltaTheta;
  SbPolyhedronSphere Rich2SphMirrorSphereSeg33(
  innerRadius,
  outerRadius,
  startPhiAngle,
  deltaPhiAngle,
  startThetaAngle,
  deltaThetaAngle);

  SbPolyhedron sbPolyhedron(Rich2SphMirrorSphereSeg33);

 {
  double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirrorHex33SubBoxQ0(sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x = Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ0;
  double z = Rh2SphMirrHexSubBoxShiftZQ0;
  double rotX = Rh2SphMirrHexSubBoxRotXQ02;
  Rich2SphMirrorHex33SubBoxQ0.Transform(
//    SbRotation(SbVec3f(1,0,0),rotX),SbVec3f(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirrorHex33SubBoxQ0);
 }

 {
  double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirrorHex33SubBoxQ1(sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x= Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ1;
  double z = Rh2SphMirrHexSubBoxShiftZQ1;
  double rotX = Rh2SphMirrHexSubBoxRotXQ13;
  Rich2SphMirrorHex33SubBoxQ1.Transform(
//    SbRotation(SbVec3f(1,0,0),rotX),SbVec3f(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirrorHex33SubBoxQ1);
 }

 {
   double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
   double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
   double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
   SbPolyhedronBox Rich2SphMirrorHex33SubBoxQ2(sizeX*0.5,sizeY*0.5,sizeZ*0.5);
   double x = Rh2SphMirrHexSubBoxShiftX;
   double y = Rh2SphMirrHexSubBoxShiftYQ2;
   double z = Rh2SphMirrHexSubBoxShiftZQ2;
   double rotX = Rh2SphMirrHexSubBoxRotXQ02;
   Rich2SphMirrorHex33SubBoxQ2.Transform(
//     SbRotation(SbVec3f(1,0,0),rotX),SbVec3f(x,y,z)
     HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
   );
   sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirrorHex33SubBoxQ2);
 }

 {
   double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
   double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
   double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
   SbPolyhedronBox Rich2SphMirrorHex33SubBoxQ3(sizeX*0.5,sizeY*0.5,sizeZ*0.5);
   double x = Rh2SphMirrHexSubBoxShiftX;
   double y = Rh2SphMirrHexSubBoxShiftYQ3;
   double z = Rh2SphMirrHexSubBoxShiftZQ3;
   double rotX = Rh2SphMirrHexSubBoxRotXQ13;
   Rich2SphMirrorHex33SubBoxQ3.Transform(
//     SbRotation(SbVec3f(1,0,0),rotX),SbVec3f(x,y,z)
     HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
   );
   sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirrorHex33SubBoxQ3);
}
*/

  double Rh2SphMirror12InnerR = 8531*mm;
  double Rh2SphMirror12OutR = Rh2SphMirror12InnerR + Rh2SphMirrorThickness;
  double Rh2SphMirr12HexDeltaTheta = (2.0*asin(Rh2SphMirrHexSegHorizSize/(2.0*Rh2SphMirror12InnerR)))*rad;
  double Rh2SphMirr12HexDeltaPhi = (2.0*asin(Rh2SphMirrHexSegVertSize/(2.0*Rh2SphMirror12InnerR)))*rad;
  double Rh2SphMirr12HexStartTheta = (pi/2.0)*rad-(Rh2SphMirr12HexDeltaTheta/2.0);
  double Rh2SphMirr12HexStartPhi = -1.0*(Rh2SphMirr12HexDeltaPhi/2.0);

  //<!-- cylider cut out for the segments around the beam pipe -->
  double Rh2SphMirCutOutBPipeCyliderR = 178*mm;
  double Rh2SphMirCutOutBPipeCyliderZ = 50*mm;
  //<!-- Shifts are in the local coord system of the mirror -->
  double Rh2SphMir12CutOutBPipeCyliderPosZ = 207*mm;
  double Rh2SphMir43CutOutBPipeCyliderPosZ = -207*mm;
  //double Rh2SphMirCutOutBPipeCyliderPosY = 0*mm;
  double Rh2SphMirCutOutBPipeCyliderRotY = 90*degree;

  //<!-- special pieces -->
  //<logvol name="lvRich2SphMirror12HexSegLeftBHole" material="RichMaterials/Rich2MirrorGlass">
  //  <subtraction name="lvRich2SphMirror12HexSegLeftBHoleSub" >

  double outerRadius = Rh2SphMirror12OutR;
  double innerRadius = Rh2SphMirror12InnerR;
  double startPhiAngle = Rh2SphMirr12HexStartPhi;
  double deltaPhiAngle = Rh2SphMirr12HexDeltaPhi;
  double startThetaAngle = Rh2SphMirr12HexStartTheta;
  double deltaThetaAngle = Rh2SphMirr12HexDeltaTheta;

/*
  printf("debug : ir %g or %g deltaPhi %g deltaTheta %g\n",
    innerRadius,
    outerRadius,
    deltaPhiAngle/degree,
    deltaThetaAngle/degree);
*/

  SbPolyhedron::SetNumberOfRotationSteps(720);
  //SbPolyhedron::SetNumberOfRotationSteps(24*7);
  SbPolyhedronSphere Rich2SphMirror12SphereLBHSeg(
  innerRadius,
  outerRadius,
  startPhiAngle,
  deltaPhiAngle,
  startThetaAngle,
  deltaThetaAngle);
  SbPolyhedron sbPolyhedron(Rich2SphMirror12SphereLBHSeg);

 {double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirror12HexSubBoxLBHQ0
    (sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x = Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ0;
  double z = Rh2SphMirrHexSubBoxShiftZQ0;
  double rotX = Rh2SphMirrHexSubBoxRotXQ02;
  Rich2SphMirror12HexSubBoxLBHQ0.Transform(
    //HEPVis::SbRotation(SbVec3d(1,0,0),rotX),SbVec3d(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirror12HexSubBoxLBHQ0);}

 {double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirror12HexSubBoxLBHQ1
    (sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x = Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ1;
  double z = Rh2SphMirrHexSubBoxShiftZQ1;
  double rotX = Rh2SphMirrHexSubBoxRotXQ13;
  Rich2SphMirror12HexSubBoxLBHQ1.Transform(
    //HEPVis::SbRotation(SbVec3d(1,0,0),rotX),SbVec3d(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirror12HexSubBoxLBHQ1);}


 {double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirror12HexSubBoxLBHQ2
    (sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x = Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ2;
  double z = Rh2SphMirrHexSubBoxShiftZQ2;
  double rotX = Rh2SphMirrHexSubBoxRotXQ02;
  Rich2SphMirror12HexSubBoxLBHQ2.Transform(
    //HEPVis::SbRotation(SbVec3d(1,0,0),rotX),SbVec3d(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirror12HexSubBoxLBHQ2);}

 {double sizeX = Rh2SPhMirrHexSubBoxLargeXSize;
  double sizeY = Rh2SPhMirrHexSubBoxLargeYSize;
  double sizeZ = Rh2SPhMirrHexSubBoxLargeZSize;
  SbPolyhedronBox Rich2SphMirror12HexSubBoxLBHQ3
    (sizeX*0.5,sizeY*0.5,sizeZ*0.5);
  double x = Rh2SphMirrHexSubBoxShiftX;
  double y = Rh2SphMirrHexSubBoxShiftYQ3;
  double z = Rh2SphMirrHexSubBoxShiftZQ3;
  double rotX = Rh2SphMirrHexSubBoxRotXQ13;
  Rich2SphMirror12HexSubBoxLBHQ3.Transform(
    //HEPVis::SbRotation(SbVec3d(1,0,0),rotX),SbVec3d(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationX(rotX),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = sbPolyhedron.OPERATION(Rich2SphMirror12HexSubBoxLBHQ3);}

 {double sizeZ = Rh2SphMirCutOutBPipeCyliderZ;
  double outerRadius = Rh2SphMirCutOutBPipeCyliderR;
  SbPolyhedron::SetNumberOfRotationSteps(24);
  SbPolyhedronTube Rich2SphMirror12HexSubBeamPipeTubeLBHH0(
        0,outerRadius,sizeZ*0.5);
  double x = Rh2SphMirror12InnerR;
  double y = 0;
  double z = Rh2SphMir12CutOutBPipeCyliderPosZ;
  double rotY = Rh2SphMirCutOutBPipeCyliderRotY;
  Rich2SphMirror12HexSubBeamPipeTubeLBHH0.Transform(
    //HEPVis::SbRotation(SbVec3d(0,1,0),rotY),SbVec3d(x,y,z)
    HepGeom::Transform3D(CLHEP::HepRotationY(rotY),CLHEP::Hep3Vector(x,y,z))
  );
  sbPolyhedron = 
    sbPolyhedron.OPERATION(Rich2SphMirror12HexSubBeamPipeTubeLBHH0);}

  return 0;
}
