@ECHO OFF
SETLOCAL

REM #///////////////////////////////////////////////////
REM #// If working with a osc_vis kit, customize the 
REM #// two below lines in order to find CLHEP and 
REM #// Geant4 on your machine. It is assumed that 
REM #// CLHEP installation is of the form :
REM #//   %CLHEP_home%\include
REM #//   %CLHEP_home%\lib\CLHEP-<version>.lib
REM #// and Geant4 :
REM #//   %g4_home%\include
REM #//   %g4_home%\lib\G4global.lib, etc..
REM #// It is assumed that the G4 global libs are
REM #// available.
REM #///////////////////////////////////////////////////
SET CLHEP_home=C:\cygwin\usr\local\CLHEP\2.0.3.1
SET g4_home=C:\cygwin\usr\local\geant4\8.2
SET g4_home=C:\cygwin\usr\local\geant4\9.0.p01
REM #///////////////////////////////////////////
REM #///////////////////////////////////////////
REM #///////////////////////////////////////////


SET bin=.

REM # /GR to enable RTTI and dynamic cast.
REM # /GX to enable exception handling (for STL).
REM # /O2 optimize
REM # /W3 warmings
SET def_cppflags=/nologo /DWIN32 /MD /GX /GR /O2 /W3 /I. /I..

SET g4_incs=/I%CLHEP_home%\include /I%g4_home%\include
SET g4_libs=/LIBPATH:%g4_home%\lib libG4graphics_reps.a libG4materials.a libG4intercoms.a libG4global.a /LIBPATH:%CLHEP_home%\lib CLHEP-2.0.3.1.lib

REM #//////////////////////////////////////////////////
REM #// application G4LabTemplateFive_polyhedrons :
REM #//////////////////////////////////////////////////

REM # application G4LabTemplateFive_polyhedrons :
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% %g4_incs%
cl.exe /c %cppflags% /Fo%bin%\G4LabTemplateFive_polyhedrons.obj /Tp..\applications\G4LabTemplateFive_polyhedrons.cxx

SET objs=%bin%\G4LabTemplateFive_polyhedrons.obj %G4_objs%

IF EXIST %bin%\G4LabTemplateFive_polyhedrons.exe DEL %bin%\G4LabTemplateFive_polyhedrons.exe
SET libs=%g4_libs%
link.exe /nologo /out:%bin%\G4LabTemplateFive_polyhedrons.exe %objs% %libs%

DEL %bin%\tmp
DEL %objs%

:build_return

ENDLOCAL
@ECHO ON
