
// this :
#include <G4LabTemplateOne/RunAction.h>

// Lib :
#include <Lib/Out.h>

// Geant4 :
#include <G4Timer.hh>
#include <G4Run.hh>

G4LabTemplateOne::RunAction::RunAction(Slash::Core::IWriter* aPrinter):fPrinter(aPrinter) {
  fTimer = new G4Timer;
}
G4LabTemplateOne::RunAction::~RunAction() {
  delete fTimer;
}
void G4LabTemplateOne::RunAction::BeginOfRunAction(const G4Run* aRun) {
  if(fPrinter) {
    Lib::Out out(*fPrinter);
    out << "### Run " << aRun->GetRunID() << " start." << Lib::endl;
  }
  fTimer->Start();
}
void G4LabTemplateOne::RunAction::EndOfRunAction(const G4Run* aRun) {
  fTimer->Stop();
  if(fPrinter) {
    Lib::Out out(*fPrinter);
    if (fTimer->IsValid()) {
      out << "number of event = " << aRun->GetNumberOfEvent()
          << " User = " << fTimer->GetUserElapsed() << "s"
          << " Real = " << fTimer->GetRealElapsed() << "s"
          << " Sys = " << fTimer->GetSystemElapsed() << "s" << Lib::endl;
    } else {
      out << "number of event = " << aRun->GetNumberOfEvent()
          << " User=****s Real=****s Sys=****s" << Lib::endl;
    }
  }
}
