#ifndef Lib_fmanip_h
#define Lib_fmanip_h

#include <string>
#include <vector>

namespace Lib {

class fmanip {
public:
  static std::string name(const std::string&);
  static bool exists(const std::string&);
  static bool remove(const std::string&);
  static bool rename(const std::string&,const std::string&);
  static bool copy(const std::string&,const std::string&);
  static bool tmpname(std::string&,const std::string& = "",const std::string& = "tmp",const std::string& = "");
  static bool read(const std::string&,std::vector<double>&);
  static bool write(const std::string&,const std::vector<std::string>&);
  static bool write(const std::string&,const std::string&);
  static bool read(const std::string&,std::vector<std::string>&);
  static bool replace(const std::string&,const std::string&,const std::string&,
               std::vector<std::string>&);
  static bool removeLines(const std::string&,const std::string&);
  static bool if_rm_eol(const std::string&,
                        const std::string&,const std::string&,
                        std::vector<std::string>&);
  static bool found(const std::string&,const std::string&,std::vector<std::string>&);
  static bool is_f77(const std::string&);
  static bool is_cpp(const std::string&);
  static void fortranLink(std::string&);
  static bool bindToFortranUnit(const std::string&,int);
  static bool move(const std::string&,const std::string&);
  static bool rm(const std::string&);
  static char* readBytes(const std::string&,long&);
  static std::string find(const std::vector<std::string>&,const std::string&);
  static std::string find(const std::string&,const std::string&,
                          const std::string&);
  static std::string towin(const std::string&);
  static bool findResource(const std::string&,const std::string&,
                           std::string&);
  static bool chmod(const std::string&,unsigned int);
  enum eWho { USER, GROUP, OTHER, ALL };
  enum eOperation { ADD, SUBTRACT };
  enum eWhat { READ, WRITE, EXECUTE };
  static bool chmod(const std::string&,eWho,eOperation,eWhat);

  static bool header(const std::string&,unsigned char header[4]);
};

}

#endif
