#
# Visualize "OnX" as 3D text.
# The scene is read from a .iv Inventor file.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_OnX')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_OnX
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_OnX
#

import OnX
import OnX as Lib

import CoinPython as Inventor

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
soPage = OnX.session().ui().currentPage()
soPage.titleVisible.setValue(Inventor.FALSE)
soPage.createRegions(Inventor.SbString("SoDisplayRegion"),1,1,0)

soRegion = soPage.currentRegion()
soRegion.color.setValue(Inventor.SbColor(0.8,0.8,0.8))

file = Lib.fmanip_name("$ONXROOT/scripts/Inventor/OnX.iv")
soRegion.cast_SoDisplayRegion().readScene(Inventor.SbString(file),"")

del soRegion
del soPage

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
