#
# Visualize a cylinder with an Inventor SoCylinder node
# created from its SoType.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_cylinder')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_cylinder
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_cylinder
#

import OnX

import CoinPython as Inventor

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
soPage = OnX.session().ui().currentPage()
soPage.title.setValue("OnX/Cylinder")

soRegion = soPage.currentRegion()
soRegion.color.setValue(Inventor.SbColor(0.4,0.4,0.4))
soSep = soRegion.cast_SoDisplayRegion().getStaticScene()

soMaterial = Inventor.SoMaterial()
soMaterial.diffuseColor.setValue(Inventor.SbVec3f(1,1,0))
soSep.addChild(soMaterial)

soType = Inventor.SoCylinder.getClassTypeId()
soNode = soType.createInstance()
#soCylinder = soNode.cast_SoCylinder()
soSep.addChild(soNode)

del soType
del soMaterial
del soNode
del soSep
del soRegion
del soPage

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
