#ifndef OnX_QPageViewer_h
#define OnX_QPageViewer_h 

// Inheritance :
#include <qwidget.h>

#include <Inventor/SbBasic.h>
class SoQtFullViewer;
class SoNode;

#include <string>

class QPainter;
class QPoint;
class QCallbackData;

#if QT_VERSION < 0x040000
class QPopupMenu;
#else
#ifdef QT3_SUPPORT
class Q3PopupMenu;
#define QPopupMenu Q3PopupMenu
#else
#error "OnX on Qt4 without -DQT3_SUPPORT not yet supported."
#endif
#endif

namespace OnX {

class QPageViewer : public QWidget {
  Q_OBJECT
public:
  QPageViewer(QWidget* = 0,const char* = 0,const char* = 0);
  virtual ~QPageViewer();
  bool setParameter(const std::string&,const std::string&);
  bool write(const std::string&,const std::string&,const std::string&);
  SoNode* sceneGraph() const;
  void emitCollect(const std::string&);
  void emitPopup(const std::string&);
  void addPopupEntry(const std::string&);
signals:
  void collect(QCallbackData&);
  void popup(QCallbackData&);
private:
  static SbBool eventCB(void*,QEvent*);
  void drawRect(QPainter&,const QPoint&,const QPoint&);
  void getRectangle(int,int,int,int,int&,int&,int&,int&);
private:
  SoQtFullViewer* fViewer;
  QPopupMenu* fPopupMenu;
  bool fRubberMove;
  QPoint fBeginMove,fEndMove;
  int fPopX,fPopY;
};

class QPageViewerPopupCallback : public QObject {
  Q_OBJECT
public:
  QPageViewerPopupCallback(QPageViewer&,const std::string&);
public slots:
  void execute();
private:
  QPageViewer& fPageViewer;
  std::string fLabel;
};

}

#if QT_VERSION < 0x040000
#else
#undef QPopupMenu
#endif


#endif

