#ifndef OnX_SDL_UI_h
#define OnX_SDL_UI_h 

// Inheritance :
//#include <Slash/Core/IManager.h>
//#include <Slash/UI/IUI.h>
#include <OnX/Core/BaseUI.h>

//#include <OnX/Core/CallbackData.h>
//namespace Slash {namespace Core {class ISession;}}
//namespace Slash {namespace Core {class IWriter;}}
//namespace Slash {namespace UI {class IScriptManager;}}

namespace OnX { class SDL_Viewer;}
#ifdef __APPLE__
namespace OnX { class NS;}
#endif

class SoNode;
class SoSDL_Widget;
class SoSeparator;
class GameViewer;
class SoFormRegion;
class SoSimpleButton;

namespace OnX {

//class SDL_UI : public virtual Slash::UI::IUI {
class SDL_UI : public BaseUI {
public: //Slash::UI::IUI :
  virtual void* cast(const std::string&) const;
  virtual void put(const std::string&);
  virtual void synchronize();
  virtual void exit(int = 0);
  virtual bool lock();
  virtual bool unlock();
  virtual void warn(const std::string&);
  virtual void show(const std::string& = "");
  virtual void hide(const std::string& = "");
  virtual bool refresh(const std::string&);
  virtual bool position(const std::string&,int&,int&);
  virtual bool parameterValue(const std::string&,std::string&);
  virtual bool setParameter(const std::string&,const std::string&);
  virtual bool write(const std::string& widget,
                     const std::string& file,
                     const std::string& format,
                     const std::string& options = "");
  virtual Slash::UI::ICyclic* createCyclic(const std::string&,
                                int,const std::string&,const std::string&);
  virtual bool lockScreen(const std::string& passwd,
                          const std::string& interp = "",
                          const std::string& script = ""); 
public:
  virtual bool notify(Slash::Core::IMessage*);
protected: //OnX::BaseUI
  virtual int nativeSteer();
  virtual bool nativeSize(void*,unsigned int&,unsigned int&);
  virtual bool createNativeWidget(Lib::ItemML&,
                            const std::string&,
                            const std::string&,
                            Lib::ItemML*);
  virtual bool destroyWidget(Lib::ItemML&);
  virtual Action* addCallback(Lib::ItemML&,
                           const std::string&,
                           const std::string&,
                           const std::string&);
  virtual void deleteCallback(Lib::ItemML&,
                              const std::string&,
                              const Action&);
  virtual std::string widgetName(Lib::ItemML&);
  virtual void showAll(Lib::ItemML&);
  virtual std::string ask(const std::string&);
public:
  SDL_UI(Slash::Core::ISession&,
         const std::string&,
         const std::vector<std::string>&);
  virtual ~SDL_UI();
  Slash::Core::IWriter& printer() const;
private:
  static void callback(void*,SoNode*);
  static void unlockCB(void*);
private:
  void addCallbacks(Lib::ItemML&,SoSimpleButton*,const std::string&);
private:
  SoSDL_Widget* fTopWidget;
  SDL_Viewer* fSDL_Viewer;
  Slash::UI::IWidget* fCurrentWidget;
  SoSeparator* fSceneGraph;
  GameViewer* fSoViewer;
  SoFormRegion* fUI_Region;
  std::string fUnlockInterp;
  std::string fUnlockScript;
#ifdef __APPLE__
  NS* fNS;
#endif
};

}

#endif

