#ifndef OnXLab_Helpers_OnXLab_h
#define OnXLab_Helpers_OnXLab_h

#include <Slash/Core/ISession.h>
#include <Slash/Data/IProcessor.h>
#include <Lib/Manager.h>

#include <Slash/UI/IUI.h>

//////////////////////////////////////////////////////////////////////////////
/// data /////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
inline void data_fill1D(
 Slash::Data::IProcessor& aAccessorManager
,const std::string& aHistogram
,const std::string& aExpressionX
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> ss;
  ss.push_back("tree=MemoryTree");
  ss.push_back("path="+aHistogram);
  ss.push_back("x="+aExpressionX);
  ss.push_back("create=no");
  aAccessorManager.execute("histogram",ss);
}
//////////////////////////////////////////////////////////////////////////////
inline void data_fill2D(
 Slash::Data::IProcessor& aAccessorManager
,const std::string& aHistogram
,const std::string& aExpressionX
,const std::string& aExpressionY
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> ss;
  ss.push_back("tree=MemoryTree");
  ss.push_back("path="+aHistogram);
  ss.push_back("dimension=2");
  ss.push_back("x="+aExpressionX);
  ss.push_back("y="+aExpressionY);
  ss.push_back("create=no");
  aAccessorManager.execute("histogram",ss);
}
//////////////////////////////////////////////////////////////////////////////
inline void data_tuple(
 Slash::Data::IProcessor& aAccessorManager
,const std::string& aPath
,const std::string& aTitle
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> ss;
  ss.push_back("tree=MemoryTree");
  ss.push_back("path="+aPath);
  ss.push_back("title="+aTitle);
  aAccessorManager.execute("tuple",ss);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
inline void data_fill1D(
 Slash::Core::ISession& aSession
,const std::string& aHistogram
,const std::string& aExpressionX
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Data::IProcessor* accessorManager = 
    Lib_findManager(aSession,"AccessorManager",Slash::Data::IProcessor);
  if(!accessorManager) return;
  data_fill1D(*accessorManager,aHistogram,aExpressionX);
}
//////////////////////////////////////////////////////////////////////////////
inline void data_fill2D(
 Slash::Core::ISession& aSession
,const std::string& aHistogram
,const std::string& aExpressionX
,const std::string& aExpressionY
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Data::IProcessor* accessorManager = 
    Lib_findManager(aSession,"AccessorManager",Slash::Data::IProcessor);
  if(!accessorManager) return;
  data_fill2D(*accessorManager,aHistogram,aExpressionX,aExpressionY);
}
//////////////////////////////////////////////////////////////////////////////
inline void data_tuple(
 Slash::Core::ISession& aSession
,const std::string& aPath
,const std::string& aTitle
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Data::IProcessor* accessorManager = 
    Lib_findManager(aSession,"AccessorManager",Slash::Data::IProcessor);
  if(!accessorManager) return;
  data_tuple(*accessorManager,aPath,aTitle);
}


#endif
