#ifndef Slash_UI_ISoViewer_h
#define Slash_UI_ISoViewer_h

/**
 * @author G.Barrand
 */

class SoNode; //Ok since a forward cast does not tie to a library.

namespace Slash {

namespace UI {

class ISoViewer {
public:
  virtual ~ISoViewer() {}
public: 
  virtual SoNode* sceneGraph() const = 0;
  virtual void setBackgroundColor(double red,double green,double blue) = 0;
  virtual void setFeedbackVisibility(bool) = 0;
  virtual void setDecoration(bool) = 0;
  virtual void setViewing(bool) = 0;
  virtual void setAutoClipping(bool) = 0;
  virtual void setHeadlight(bool) = 0;
  virtual void render() = 0;
  virtual void viewAll() = 0;
public:
  //INTERNAL
  virtual void setSceneGraph(SoNode*) = 0;
};

} //UI

} //Slash

#endif
